package com.sun.jmx.snmp.IPAcl;

import java.util.Vector;
import java.net.InetAddress;
import java.util.Hashtable;

class SimpleNode implements Node
{
    protected Node parent;
    protected Node[] children;
    protected int id;
    protected Parser parser;
    
    public SimpleNode(int id) {
        this.id = id;
    }
    
    public SimpleNode(Parser parser, int n) {
        this(n);
        this.parser = parser;
    }
    
    public static Node jjtCreate(int n) {
        return new SimpleNode(n);
    }
    
    public static Node jjtCreate(Parser parser, int n) {
        return new SimpleNode(parser, n);
    }
    
    @Override
    public void jjtOpen() {
    }
    
    @Override
    public void jjtClose() {
    }
    
    @Override
    public void jjtSetParent(Node parent) {
        this.parent = parent;
    }
    
    @Override
    public Node jjtGetParent() {
        return this.parent;
    }
    
    @Override
    public void jjtAddChild(Node node, int n) {
        if (this.children == null) {
            this.children = new Node[n + 1];
        }
        else if (n >= this.children.length) {
            Node[] children = new Node[n + 1];
            System.arraycopy(this.children, 0, children, 0, this.children.length);
            this.children = children;
        }
        this.children[n] = node;
    }
    
    @Override
    public Node jjtGetChild(int n) {
        return this.children[n];
    }
    
    @Override
    public int jjtGetNumChildren() {
        return (this.children == null) ? 0 : this.children.length;
    }
    
    public void buildTrapEntries(Hashtable<InetAddress, Vector<String>> hashtable) {
        if (this.children != null) {
            for (int i = 0; i < this.children.length; ++i) {
                SimpleNode simpleNode = (SimpleNode)this.children[i];
                if (simpleNode != null) {
                    simpleNode.buildTrapEntries(hashtable);
                }
            }
        }
    }
    
    public void buildInformEntries(Hashtable<InetAddress, Vector<String>> hashtable) {
        if (this.children != null) {
            for (int i = 0; i < this.children.length; ++i) {
                SimpleNode simpleNode = (SimpleNode)this.children[i];
                if (simpleNode != null) {
                    simpleNode.buildInformEntries(hashtable);
                }
            }
        }
    }
    
    public void buildAclEntries(PrincipalImpl principalImpl, AclImpl aclImpl) {
        if (this.children != null) {
            for (int i = 0; i < this.children.length; ++i) {
                SimpleNode simpleNode = (SimpleNode)this.children[i];
                if (simpleNode != null) {
                    simpleNode.buildAclEntries(principalImpl, aclImpl);
                }
            }
        }
    }
    
    @Override
    public String toString() {
        return ParserTreeConstants.jjtNodeName[this.id];
    }
    
    public String toString(String str) {
        return str + this.toString();
    }
    
    public void dump(String str) {
        if (this.children != null) {
            for (int i = 0; i < this.children.length; ++i) {
                SimpleNode simpleNode = (SimpleNode)this.children[i];
                if (simpleNode != null) {
                    simpleNode.dump(str + " ");
                }
            }
        }
    }
}
